#Include once "windows.bi"
#include once "win/commctrl.bi"

const FB_InputBox = "FB_InputBox"

const IB_btnCancel = 6660
Const IB_btnOK     = 6661
const IB_txtInput  = 6662
const IB_lblPrompt = 6663

Declare Function InputBox(sIB_Title As String, sIB_Prompt As String, sIB_Default As String = "") As String
declare sub IB_Register_Classes
declare function IB_Message_Loop as integer
declare function IB_Wnd_Proc(byval thiswnd as hwnd, byval message as uinteger, byval w_param as wparam, byval l_param as lparam) as lresult
declare function IB_Create_Wnd as hwnd
declare sub IB_Create_Wnd_Content(byval parent as hwnd)

dim shared IB_Instance as hmodule
dim shared IB_h_Font as HFONT
Dim Shared IB_Result As String
Dim Shared IB_Title As String
Dim Shared IB_Prompt As String
Dim Shared IB_Default As String

Public Function InputBox(sIB_Title As String, sIB_Prompt As String, sIB_Default As String = "") As String
	IB_Title=sIB_Title
	IB_Prompt=sIB_Prompt
	IB_Default=sIB_Default
	IB_Instance = GetModuleHandle(null)
	InitCommonControls
	IB_Register_Classes
	IB_h_Font = CreateFont(-13, 0, 0, 0, FW_NORMAL, 0, _
			0, 0, ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, _
			DEFAULT_QUALITY, DEFAULT_PITCH or FF_DONTCARE, "Times New Roman")
	IB_Create_Wnd
	While IB_Message_Loop <> 0
	
	Wend
	Return IB_Result
End Function

function IB_Wnd_Proc(byval thiswnd as hwnd, byval message as uinteger, byval w_param as wparam, byval l_param as lparam) as lresult
	select case message
	case WM_COMMAND
		select case loword(w_param)
			Case IB_btnCancel
				IB_Result=""
				PostQuitMessage 0
				
			Case IB_btnOK
				Dim As ZString * 31 zIB_Result
				GetDlgItemText(thiswnd,IB_txtInput,zIB_Result,30)
				IB_Result=zIB_Result
				DestroyWindow thiswnd

		end select

	case WM_CREATE
		IB_Create_Wnd_Content thiswnd

	case WM_CLOSE
		DestroyWindow thiswnd

	case WM_DESTROY:
		PostQuitMessage 0

	case else
		return DefWindowProc(thiswnd, message, w_param, l_param)
	end select
	return 0
end function

function IB_Create_Wnd as hwnd
	dim wnd as hwnd
	Dim As Integer xres,yres
	xres=GetSystemMetrics(SM_CXSCREEN)
	yres=GetSystemMetrics(SM_CYSCREEN)
	wnd = CreateWindowEx(&h00000180, FB_InputBox, IB_Title, &h14CB0000, xres\2-400\2, yres\2-130\2, 400, 130, null, null, IB_Instance, null)
	ShowWindow wnd, SW_SHOWNORMAL
	SetFocus(GetDlgItem(wnd,IB_txtInput))
	UpdateWindow wnd
	return wnd
end function

sub IB_Create_Wnd_Content(byval parent as hwnd)
	dim wnd as hwnd
	wnd = CreateWindowEx(&h00000200, "Edit", IB_Default, &h50010080, 8, 32, 376, 24, parent, cast(hmenu, IB_txtInput), IB_Instance, null)
	SendMessage wnd, WM_SETFONT, cast(wparam, IB_h_Font), TRUE
	wnd = CreateWindowEx(&h00000000, "Static", IB_Prompt, &h50000300, 8, 8, 248, 24, parent, cast(hmenu, IB_lblPrompt), IB_Instance, null)
	SendMessage wnd, WM_SETFONT, cast(wparam, IB_h_Font), TRUE
	wnd = CreateWindowEx(&h00000000, "Button", "Cancel", &h50012F00, 288, 64, 96, 32, parent, cast(hmenu, IB_btnCancel), IB_Instance, null)
	SendMessage wnd, WM_SETFONT, cast(wparam, IB_h_Font), TRUE
	wnd = CreateWindowEx(&h00000000, "Button", "OK", &h50012F00, 8, 64, 96, 32, parent, cast(hmenu, IB_btnOK), IB_Instance, null)
	SendMessage wnd, WM_SETFONT, cast(wparam, IB_h_Font), TRUE
end sub

sub IB_Register_Classes
	dim wc as WNDCLASS

	with wc
		.cbClsExtra    = 0
		.cbWndExtra    = 0
		.hbrBackground = cast(hbrush, COLOR_3DFACE + 1)
		.hCursor       = LoadCursor(null, byval IDC_ARROW)
		.hIcon         = LoadIcon(null, byval IDI_APPLICATION)
		.hInstance     = IB_Instance
		.lpszMenuName  = null
		.style         = CS_PARENTDC or CS_DBLCLKS
	end with

	wc.lpfnWndProc   = @IB_Wnd_Proc
	wc.lpszClassName = strptr(FB_InputBox)

	RegisterClass @wc
end sub

function IB_Message_Loop as integer
	Dim message as MSG
	while (GetMessage(@message, null, 0, 0) <> false)
		TranslateMessage @message
		DispatchMessage @message
	wend
	DeleteObject IB_h_Font
	Return message.wParam
end function
